(function() {

    var features;

    function buildFeaturesPromises() {
        features = [
            'api.window.MozMobileNetworkInfo',
            'api.window.Navigator.mozBluetooth',
            'api.window.Navigator.mozContacts',
            'api.window.Navigator.getDeviceStorage',
            'api.window.Navigator.addIdleObserver',
            'api.window.Navigator.mozNetworkStats',
            'api.window.Navigator.push',
            'api.window.Navigator.mozTime',
            'api.window.Navigator.mozFMRadio',
            'api.window.Navigator.mozCameras',
            'api.window.Navigator.mozAlarms',
            'api.window.Navigator.mozTCPSocket',
            'api.window.Navigator.mozInputMethod',
            'api.window.Navigator.mozMobileConnections',
            'api.window.Navigator.getMobileIdAssertion',
            'api.window.XMLHttpRequest.mozSystem',
            'manifest.chrome.navigation',
            'manifest.origin',
            'manifest.precompile',
            'manifest.redirects'
        ];

        var promises = [];
        features.forEach(function(featureName) {
            promises.push(navigator.hasFeature(featureName));
        });
        return Promise.all(promises);
    }

    buildFeaturesPromises().then(function(promises) {
        console.log(promises);

        var table = document.createElement('table');
        features.forEach(function(featureName, i) {
            var result = promises[i];
            var row = table.insertRow();
            var cell = row.insertCell();
            cell.appendChild(document.createTextNode(featureName));
            cell = row.insertCell();
            cell.appendChild(document.createTextNode(result));
            row.style.backgroundColor = result ? 'green' : 'red';
        });
        document.body.appendChild(table);
    });

})();
